var fs = require('fs')
var http = require('http')
var url = require('url')
var path = require('path')


var createServer = function(currentPath) {
  http.createServer(function(req, res) {
    var pathname = url.parse(req.url).pathname
    switch(pathname) {
      case '/':
        showAllFile(res, currentPath)
        break;
      case '/files':
        download(req, res, currentPath)
        break;
      default:
        showError(res)
        break;
    }
  }).listen(8888)
}

function showAllFile(res, currentPath) {
  fs.readFile(path.join(__dirname, '..', 'public/index.html'), function(err, data) {
    var fileString = ""
    fs.readdir(currentPath, function(err, files) {
      files.map(function(file) {
        fileString += `<a href=files?file=${file}>${file}</a><br>`
      })
      res.write(data.toString().replace(/%/g, fileString))
      res.end()
    })
  })
}

function showError(res) {
  fs.readFile(path.join(__dirname, '..', 'public/error.html'), function(err, data) {
    res.write(data)
    res.end()
  })
}

function download(req, res, currentPath) {
  var query = url.parse(req.url).query
  var fileName = decodeURI(query.slice(5))
  var filepath = `${currentPath}/${fileName}`
  var fileStream = fs.createReadStream(filepath)
  res.setHeader('Content-disposition', 'attachment; filename=' + encodeURIComponent(fileName))
  fileStream.pipe(res)
}

module.exports = createServer
